using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace StatisticalAnalyzer
{
	/// <summary>
	/// Summary description for ComparisonOfGraphs.
	/// </summary>
	public class ComparisonOfGraphs : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button Show_Btn;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button YValue1_Btn;
		private System.Windows.Forms.TextBox YValue1_TB;
		private System.Windows.Forms.Button YValue2_Btn;
		private System.Windows.Forms.TextBox YValue2_TB;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox Con1_TB;
		private System.Windows.Forms.TextBox Con2_TB;
		private System.Windows.Forms.Button Reset_Btn;
		private System.Windows.Forms.Button ResetTB_Btn;
		private System.Windows.Forms.ListBox XParam_LB;
		private System.Windows.Forms.ListBox YParam_LB;

		private string XParam = "";
		private string YParam = "";
		private string selectedNumYCurve;
		private ArrayList XInterval;
		private ArrayList YValue1;
        private ArrayList YValue2;
		private string selectedXParam = "";
        private string selectedYParam = "";

		
		public ComparisonOfGraphs()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			XInterval = new ArrayList();
			YValue1 = new ArrayList();
			YValue2 = new ArrayList();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.YValue1_Btn = new System.Windows.Forms.Button();
			this.YValue1_TB = new System.Windows.Forms.TextBox();
			this.Show_Btn = new System.Windows.Forms.Button();
			this.YValue2_Btn = new System.Windows.Forms.Button();
			this.YValue2_TB = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.Con1_TB = new System.Windows.Forms.TextBox();
			this.Con2_TB = new System.Windows.Forms.TextBox();
			this.Reset_Btn = new System.Windows.Forms.Button();
			this.ResetTB_Btn = new System.Windows.Forms.Button();
			this.XParam_LB = new System.Windows.Forms.ListBox();
			this.YParam_LB = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(24, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 32);
			this.label1.TabIndex = 0;
			this.label1.Text = "X parameter :";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(360, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(112, 24);
			this.label2.TabIndex = 2;
			this.label2.Text = " Y parameter:";
			// 
			// YValue1_Btn
			// 
			this.YValue1_Btn.Location = new System.Drawing.Point(24, 384);
			this.YValue1_Btn.Name = "YValue1_Btn";
			this.YValue1_Btn.Size = new System.Drawing.Size(128, 40);
			this.YValue1_Btn.TabIndex = 6;
			this.YValue1_Btn.Text = "Add Y1 Value";
			this.YValue1_Btn.Click += new System.EventHandler(this.YValue_Btn_Click);
			// 
			// YValue1_TB
			// 
			this.YValue1_TB.Location = new System.Drawing.Point(176, 400);
			this.YValue1_TB.Name = "YValue1_TB";
			this.YValue1_TB.Size = new System.Drawing.Size(96, 24);
			this.YValue1_TB.TabIndex = 7;
			this.YValue1_TB.Text = "";
			// 
			// Show_Btn
			// 
			this.Show_Btn.Location = new System.Drawing.Point(24, 496);
			this.Show_Btn.Name = "Show_Btn";
			this.Show_Btn.Size = new System.Drawing.Size(432, 32);
			this.Show_Btn.TabIndex = 10;
			this.Show_Btn.Text = "Show Graph";
			this.Show_Btn.Click += new System.EventHandler(this.Show_Btn_Click);
			// 
			// YValue2_Btn
			// 
			this.YValue2_Btn.Location = new System.Drawing.Point(24, 440);
			this.YValue2_Btn.Name = "YValue2_Btn";
			this.YValue2_Btn.Size = new System.Drawing.Size(128, 40);
			this.YValue2_Btn.TabIndex = 11;
			this.YValue2_Btn.Text = "Add Y2 Value";
			this.YValue2_Btn.Click += new System.EventHandler(this.YValue2_Btn_Click);
			// 
			// YValue2_TB
			// 
			this.YValue2_TB.Location = new System.Drawing.Point(168, 448);
			this.YValue2_TB.Name = "YValue2_TB";
			this.YValue2_TB.Size = new System.Drawing.Size(96, 24);
			this.YValue2_TB.TabIndex = 12;
			this.YValue2_TB.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(288, 344);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(152, 24);
			this.label3.TabIndex = 13;
			this.label3.Text = " Condition";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// Con1_TB
			// 
			this.Con1_TB.Location = new System.Drawing.Point(288, 400);
			this.Con1_TB.Name = "Con1_TB";
			this.Con1_TB.Size = new System.Drawing.Size(152, 24);
			this.Con1_TB.TabIndex = 14;
			this.Con1_TB.Text = "";
			// 
			// Con2_TB
			// 
			this.Con2_TB.Location = new System.Drawing.Point(288, 448);
			this.Con2_TB.Name = "Con2_TB";
			this.Con2_TB.Size = new System.Drawing.Size(152, 24);
			this.Con2_TB.TabIndex = 15;
			this.Con2_TB.Text = "";
			// 
			// Reset_Btn
			// 
			this.Reset_Btn.Location = new System.Drawing.Point(496, 416);
			this.Reset_Btn.Name = "Reset_Btn";
			this.Reset_Btn.Size = new System.Drawing.Size(152, 32);
			this.Reset_Btn.TabIndex = 16;
			this.Reset_Btn.Text = "Reset Y Values";
			this.Reset_Btn.Click += new System.EventHandler(this.Reset_Btn_Click);
			// 
			// ResetTB_Btn
			// 
			this.ResetTB_Btn.Location = new System.Drawing.Point(480, 496);
			this.ResetTB_Btn.Name = "ResetTB_Btn";
			this.ResetTB_Btn.Size = new System.Drawing.Size(208, 32);
			this.ResetTB_Btn.TabIndex = 18;
			this.ResetTB_Btn.Text = "Reset Text Boxes";
			this.ResetTB_Btn.Click += new System.EventHandler(this.ResetTB_Btn_Click);
			// 
			// XParam_LB
			// 
			this.XParam_LB.ItemHeight = 18;
			this.XParam_LB.Location = new System.Drawing.Point(24, 64);
			this.XParam_LB.Name = "XParam_LB";
			this.XParam_LB.Size = new System.Drawing.Size(264, 256);
			this.XParam_LB.TabIndex = 19;
			this.XParam_LB.SelectedIndexChanged += new System.EventHandler(this.XParam_LB_SelectedIndexChanged);
			// 
			// YParam_LB
			// 
			this.YParam_LB.ItemHeight = 18;
			this.YParam_LB.Location = new System.Drawing.Point(312, 64);
			this.YParam_LB.Name = "YParam_LB";
			this.YParam_LB.Size = new System.Drawing.Size(368, 256);
			this.YParam_LB.TabIndex = 20;
			this.YParam_LB.SelectedIndexChanged += new System.EventHandler(this.YParam_LB_SelectedIndexChanged);
			// 
			// ComparisonOfGraphs
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(7, 17);
			this.ClientSize = new System.Drawing.Size(696, 541);
			this.Controls.Add(this.YParam_LB);
			this.Controls.Add(this.XParam_LB);
			this.Controls.Add(this.ResetTB_Btn);
			this.Controls.Add(this.Reset_Btn);
			this.Controls.Add(this.Con2_TB);
			this.Controls.Add(this.Con1_TB);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.YValue2_TB);
			this.Controls.Add(this.YValue2_Btn);
			this.Controls.Add(this.Show_Btn);
			this.Controls.Add(this.YValue1_TB);
			this.Controls.Add(this.YValue1_Btn);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "ComparisonOfGraphs";
			this.Text = "ComparisonOfGraphs";
			this.Load += new System.EventHandler(this.ComparisonOfGraphs_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void ComparisonOfGraphs_Load(object sender, System.EventArgs e)
		{
			SetXParameter();
			SetYParameter();
		}



		private void YValue_Btn_Click(object sender, System.EventArgs e)
		{
			YValue1.Add(YValue1_TB.Text);
            YValue1_TB.Text = "";
		}

		private void YValue2_Btn_Click(object sender, System.EventArgs e)
		{
			YValue2.Add(YValue2_TB.Text);
			YValue2_TB.Text = "";
		}

		private double[] getDouble(ArrayList p_al)
		{
            double[] d = new double[p_al.Count];
			try
			{
				for(int i =0; i<p_al.Count; i++)
				{ 
					d[i] = double.Parse(p_al[i].ToString());
				}
			}
			catch(Exception e)
			{
               MessageBox.Show("Exception in getDouble(): "+e.Message);
			}
			return d;
 		}
		private void Show_Btn_Click(object sender, System.EventArgs e)
		{
			if(!selectedYParam.Equals("") &&
				!selectedXParam.Equals("") &&
				!Con1_TB.Text.Equals("") &&
				!Con2_TB.Text.Equals("") &&
				(YValue1.Count!=0) &&
				(YValue2.Count!=0) &&
				(XInterval.Count!=0))
			{
				string con1 = Con1_TB.Text;
				string con2 = Con2_TB.Text;
				double[] y1 = getDouble(YValue1);
				double[] y2 = getDouble(YValue2);
				double[] x = getDouble(XInterval);

				Graph G = new Graph(selectedXParam, selectedYParam, x, y1, y2, con1, con2);
				G.Top = 0;
				G.BringToFront();
				G.Focus();
				G.Visible = true;
			}
			else
			{
               MessageBox.Show("Please check the inputs!");
			}
		}

		private void SetXParameter()
		{
			try
			{
				XParam_LB.Items.Add("Speed");
				XParam_LB.Items.Add("Pause Time");
				XParam_LB.Items.Add("SWS");
				//XParam_LB.Items.Add("Traffic Control Parameter");
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in SetXParameter(): "+e.Message);
			}
		}

		private void SetYParameter()
		{
			try
			{
				YParam_LB.Items.Add(COMMONCONSTANTS.AVE_LATENCY_FINDING_ROUTE);
				YParam_LB.Items.Add(COMMONCONSTANTS.AVE_LATENCY_DELIVERYING_DP);
				YParam_LB.Items.Add(COMMONCONSTANTS.DELIVERY_RATIO_DP);
				YParam_LB.Items.Add(COMMONCONSTANTS.NORMALIZED_CONTROL_OVERHEAD);
				YParam_LB.Items.Add(COMMONCONSTANTS.THROUGHPUT);
				YParam_LB.Items.Add(COMMONCONSTANTS.NUM_OF_CACHE_ENTRIES);
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in SetYParameter(): "+e.Message);
			}
		}

		private void Reset_Btn_Click(object sender, System.EventArgs e)
		{
			YValue1.Clear();
			YValue2.Clear();
			
		}

		private void ResetXInterval_Btn_Click(object sender, System.EventArgs e)
		{
			XInterval.Clear();
		}

		private void ResetTB_Btn_Click(object sender, System.EventArgs e)
		{
			Con1_TB.Text = "";
			Con2_TB.Text = "";
		}

		private void YParam_LB_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		   selectedYParam = YParam_LB.SelectedItem.ToString();
		}

		private void XParam_LB_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			selectedXParam = XParam_LB.SelectedItem.ToString();
			SetXInterval();
		}
        
		private void SetXInterval()
		{
			if(selectedXParam.Equals("Speed"))
			{
				XInterval.Add("10");
				XInterval.Add("20");
				XInterval.Add("40");
				XInterval.Add("80");
				XInterval.Add("160");
				XInterval.Add("320");
				XInterval.Add("640");
			}
			else if(selectedXParam.Equals("SWS"))
			{
				for(int i =1; i<7; i++)
				{
                   XInterval.Add(i.ToString());
				}
			}
			else if(selectedXParam.Equals("Pause Time"))
			{
				XInterval.Add("15");
				XInterval.Add("30");
				XInterval.Add("60");
				XInterval.Add("120");
				XInterval.Add("240");
				XInterval.Add("480");
				XInterval.Add("960");
			}
		}


	}
}
