using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using ZedGraph;

namespace StatisticalAnalyzer
{
	/// <summary>
	/// Summary description for Graph.
	/// </summary>
	public class Graph : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private string xparam;
		private string yparam;
		private double[] XInterval;
		private double[] Y1Value;
		private double[] Y2Value;
		private string condition1;
        private string condition2;
		private GraphPane myPane;

		public Graph()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public Graph(string p_xparam, string p_yparam, double[] p_XInterval, 
			double[] p_Y1Value, double[] p_Y2Value, string p_con1, string p_con2)
		{
			InitializeComponent();
			xparam = p_xparam;
			yparam = p_yparam;
			XInterval = p_XInterval;
			Y1Value = p_Y1Value;
			Y2Value = p_Y2Value;
			condition1 = p_con1;
			condition2 = p_con2;			
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// Graph
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(728, 477);
			this.Name = "Graph";
			this.Text = "Graph";
			this.Load += new System.EventHandler(this.Graph_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Graph_Paint);

		}
		#endregion

		private void Graph_Load(object sender, System.EventArgs e)
		{
			ShowGraph();
		}

		private string getXParam(string p_param)
		{
			string param = "";
			try
			{
				if(p_param.Equals("Speed"))
				{
					param = p_param+" (m/s)"; 
				}
				else if(p_param.Equals("Pause Time"))
				{
					param = p_param+" (sec)"; 
				}
				else
				{
					param = p_param;
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in getXParam(): "+e.Message);
			}
			return param;
		}

		private string getYParam(string p_param)
		{
			string param = "";
			try
			{
				if(p_param.Equals(COMMONCONSTANTS.AVE_LATENCY_FINDING_ROUTE) ||
					p_param.Equals(COMMONCONSTANTS.AVE_LATENCY_DELIVERYING_DP))
				{
					param = p_param+" (sec)"; 
				}
				else
				{
					param = p_param;
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in getYParam(): "+e.Message);
			}
			return param;

		}
		private void ShowGraph()
		{
			string title = xparam + " vs. "+yparam;

			string strXParam = getXParam(xparam);
			string strYParam = getYParam(yparam);
			myPane = new GraphPane(new Rectangle(20,20, this.Width-50, this.Height-110), 
				title, strXParam, strYParam);
            // MessageBox.Show(xparam+" "+yparam+" "+XInterval.Length+" "+Y1Value.Length+" "+Y2Value.Length);
		
			CurveItem myCurve1 = myPane.AddCurve(condition1, XInterval, Y1Value, Color.Red, SymbolType.Star);
			CurveItem myCurve2 = myPane.AddCurve(condition2, XInterval, Y2Value, Color.Blue, SymbolType.Diamond);
			myPane.AxisChange();			
			
		}

		private void Graph_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			myPane.Draw(e.Graphics);
		}



	}
}
